package jp.marunomaruno.judeapi2cpp.gui;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * t@CfBNg[It@C`[U[ŕKvȃZbgplɂNXłB
 * @author  maruno
 * @version 1.0, 2007-12-20
 * @since   1.0
 */
public class FileChooserPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	private JButton button = null;
	private JLabel label = null;
	private JTextField field = null;
	private ActionListener listener = null;
	
	private static final Dimension LABEL_DIM = new Dimension(132, 16);  //  @jve:decl-index=0:
	private static final Dimension FIELD_DIM = new Dimension(260, 20);  //  @jve:decl-index=1:
	private static final Dimension BUTTON_DIM = new Dimension(60, 20);  //  @jve:decl-index=1:

	/**
	 * xAeLXgtB[hAt@C`[U[̃Xi[w肵ẴNX̃CX^X𐶐RXgN^[łB
	 * @param label x
	 * @param field eLXgtB[h
	 * @param listener Xi[
	 */
	public FileChooserPanel(JLabel label, JTextField field, ActionListener listener) {
		this.label = label;
		this.field = field;
		this.listener = listener;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.fill = GridBagConstraints.VERTICAL;
		gridBagConstraints11.gridy = 0;
		gridBagConstraints11.weightx = 1.0;
		gridBagConstraints11.gridx = 1;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 0;
		label.setPreferredSize(LABEL_DIM);
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 2;
		gridBagConstraints.gridy = 0;
		this.setSize(LABEL_DIM.width + FIELD_DIM.width + BUTTON_DIM.width, 224);
		this.setLayout(new GridBagLayout());
		this.add(getButton(), gridBagConstraints);
		this.add(label, gridBagConstraints1);
		this.add(getField(), gridBagConstraints11);
	}

	/**
	 * This method initializes button	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton() {
		if (button == null) {
			button = new JButton();
			button.setText("Q ...");
			button.addActionListener(listener);
		}
		if (listener == null) {
			button.setEnabled(false);
		}

		return button;
	}

	/**
	 * This method initializes field	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getField() {
		if (field == null) {
			field = new JTextField();
		}
		field.setPreferredSize(FIELD_DIM);
		return field;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
