package jp.marunomaruno.judeapi2cpp;
import static jp.marunomaruno.judeapi2cpp.JudeApi2CppUtil.getName;

import java.util.Comparator;

import com.change_vision.jude.api.inf.model.INamedElement;


public class StereotypeAndNameComparator<T> implements Comparator<T> {

	public int compare(T o1, T o2) {
		if (o1 == null) {
			return -1;
		}
		
		if (o2 == null) {
			return 1;
		}
		
		String s1;
		try {
			s1 = ((INamedElement) o1).getStereotypes()[0] + " " + getName((INamedElement) o1);
		} catch (RuntimeException e) {
			s1 = " " + getName((INamedElement) o1);
		}
		String s2;
		try {
			s2 = ((INamedElement) o2).getStereotypes()[0] + " " + getName((INamedElement) o2);
		} catch (RuntimeException e) {
			s2 = " " + getName((INamedElement) o2);
		}
		return s1.compareTo(s2);
	}

}
