package jp.marunomaruno.judeapi2cpp.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JTextField;

import jp.marunomaruno.judeapi2cpp.JudeApi2CppProperty;

/**
 * ĐfBNg[I`[U[̃NXB́ACt[́uQƁv{^NbN邱ƂŋN܂B
 * ĐfBNg[̃pX́AeLXgtB[h̒lƂĐݒ肳܂B
 * 
 * @author  maruno
 * @version 1.0, 2007-12-20
 * @since   1.0
 */
public class DestinationDirectoryChooser implements ActionListener {
	private JTextField field;
	private File directory;
	
	/**
	 * eLXgtB[hw肵āÂĐfBNg[`[U[̃CX^X𐶐RXgN^[łB
	 * @param field eLXgtB[h
	 */
	public DestinationDirectoryChooser(JTextField field) {
		this.field = field;
		directory = null;
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		JFileChooser chooser = new JFileChooser(field.getText());
		chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int result = chooser.showOpenDialog( null );

		if(result==JFileChooser.APPROVE_OPTION) {
			directory = chooser.getSelectedFile();
			JudeApi2CppProperty.getInstance().setDestinationDirectory(directory.getPath());
			System.out.println( "selected " + directory.getPath() );
			field.setText(directory.getPath());
		}
	}
}
